import tty, sys, termios
import time
import os
#from gpiozero import Button
from time import sleep
import curses
import datetime

import RPi.GPIO as GPIO # Import Raspberry Pi GPIO library
GPIO.setwarnings(False) # Ignore warning for now
GPIO.setmode(GPIO.BOARD) # Use physical pin numbering
GPIO.setup(10, GPIO.IN, pull_up_down=GPIO.PUD_DOWN) 
GPIO.setup(12, GPIO.IN, pull_up_down=GPIO.PUD_DOWN) 
# os.chdir('py')
# exec(open('rr.py').read())
# dump_errors(odrv0)


stdscr = curses.initscr()
curses.noecho()
stdscr.nodelay(1) # set getch() non-blocking

'''
odrv0.vbus_voltage
odrv0.axis0.motor.config.current_lim = 10
odrv0.axis0.controller.config.vel_limit = 30
odrv0.axis0.motor.config.calibration_current = 10 # 10
odrv0.config.brake_resistance = 2
odrv0.axis0.motor.config.pole_pairs = 7 #20
odrv0.axis0.motor.config.torque_constant = 8.27/150 # 8.27 / 90
odrv0.axis0.motor.config.motor_type = MOTOR_TYPE_HIGH_CURRENT
odrv0.axis0.encoder.config.cpr = 8192
odrv0.axis0.trap_traj.config.accel_limit = 5
odrv0.axis0.trap_traj.config.vel_limit = 1
odrv0.axis0.trap_traj.config.decel_limit = 5
odrv0.save_configuration()

print('Init')
odrv0.axis0.requested_state = AXIS_STATE_FULL_CALIBRATION_SEQUENCE
print('Venter litt')
time.sleep(15)
odrv0.axis0.encoder.set_linear_count(0)
print('Encoder pos = 0')
odrv0.axis0.trap_traj.config.accel_limit = 5
odrv0.axis0.trap_traj.config.vel_limit = 1
odrv0.axis0.trap_traj.config.decel_limit = 5
odrv0.axis0.controller.config.input_mode = INPUT_MODE_TRAP_TRAJ
odrv0.axis0.requested_state = AXIS_STATE_CLOSED_LOOP_CONTROL
print('Klar\n')

odrv0.axis0.controller.config.vel_integrator_gain
'''
     
while 1 == 1:
  #x = sys.stdin.read(1)[0]
  c = stdscr.getch()

  if c == ord('s'):
     print('Init')
     odrv0.axis0.requested_state = AXIS_STATE_CLOSED_LOOP_CONTROL
     print('Klar')
  if c == ord('S'):
     print('Init')
     odrv0.axis0.requested_state = AXIS_STATE_FULL_CALIBRATION_SEQUENCE
     print('Venter litt')
     time.sleep(15)
     odrv0.axis0.encoder.set_linear_count(0)
     print('Encoder pos = 0')
     odrv0.axis0.trap_traj.config.accel_limit = 5
     odrv0.axis0.trap_traj.config.vel_limit = 1
     odrv0.axis0.trap_traj.config.decel_limit = 5
     odrv0.axis0.controller.config.input_mode = INPUT_MODE_TRAP_TRAJ
     odrv0.axis0.requested_state = AXIS_STATE_CLOSED_LOOP_CONTROL
     print('Klar')
  if c == ord('1'):
     odrv0.axis0.trap_traj.config.vel_limit = 1
     odrv0.axis0.controller.input_pos = 0.2     
  if c == ord('2'):
     odrv0.axis0.trap_traj.config.vel_limit = 1
     odrv0.axis0.controller.input_pos = 0  
  if c == ord('8'):
     odrv0.axis0.trap_traj.config.accel_limit = 5
     odrv0.axis0.trap_traj.config.vel_limit = 30
     odrv0.axis0.trap_traj.config.decel_limit = 5
     odrv0.axis0.controller.config.input_mode = INPUT_MODE_TRAP_TRAJ
     odrv0.axis0.requested_state = AXIS_STATE_CLOSED_LOOP_CONTROL
     odrv0.axis0.controller.input_pos = 20    
  if c == ord('9'):
     odrv0.axis0.trap_traj.config.accel_limit = 5
     odrv0.axis0.trap_traj.config.vel_limit = 30
     odrv0.axis0.trap_traj.config.decel_limit = 5
     odrv0.axis0.controller.config.input_mode = INPUT_MODE_TRAP_TRAJ
     odrv0.axis0.requested_state = AXIS_STATE_CLOSED_LOOP_CONTROL
     odrv0.axis0.controller.input_pos = 0  
  if c == ord('r'):    
     odrv0.axis0.encoder.set_linear_count(0) 
  if c == ord('R'):
     odrv0.reboot()
     print('Boot')  
  if c == ord('q'):
     odrv0.axis0.requested_state = AXIS_STATE_IDLE
     print('Stopper')     
  if c == ord('e'):
     odrv0.axis0.requested_state = AXIS_STATE_IDLE
     curses.endwin()
     break
     print('Stopper')
  if GPIO.input(10) == GPIO.HIGH: 
     odrv0.axis0.trap_traj.config.vel_limit = 4
     odrv0.axis0.controller.input_pos = 0.5  
     time.sleep(1)
  if GPIO.input(12) == GPIO.HIGH:
     odrv0.axis0.trap_traj.config.vel_limit = 4
     odrv0.axis0.controller.input_pos = 0  
     time.sleep(1)    
 
