// Tar i mot data 0-2000
// . .  lenMsb lenLsb   data1Msb data1lsb   data2msb data2lsb

/*
  cntArrDecim = cntDecimate(cntArr44, cl2sa(corStrArr, 1), cl2sa(corStrArr, 5), 290);
  cntArrDecim = 2000 * (cntArrDecim + 1);
  cntArrDecim = cntArrDecim(:, 1); % foreløbig
  len = length(cntArrDecim);

  s = serial('/dev/ttyUSB0', 'BaudRate', 9600); fopen(s);
  fwrite(s, 46, 'uint8'); fwrite(s, 46, 'uint8');
  fwrite(s, bitshift(len,-8), 'uint8'); fwrite(s, bitand(len,255), 'uint8');
  for i = 1 : len
  pause(0.01);
  fwrite(s, bitshift(cntArrDecim(i),-8), 'uint8'); fwrite(s, bitand(cntArrDecim(i),255), 'uint8');
  end
  fclose(s); s=[];

*/

#include <SPI.h>
#include <SD.h>

const int chipSelect = 8;
File txtFile;

unsigned int antDataWords = 0;
int incomingByte = 0;

void setup() {
  pinMode(10, OUTPUT);
  //digitalWrite(8, HIGH);
  pinMode(3, OUTPUT);
  digitalWrite(3, LOW);
  Serial.begin(9600);
}

// ***********************************************************

void loop(void) 
{
  // Start ..
  int ferdig = 0;
  int incomingByte = 0;
  int incomingByteOld = 0;
  // Kjører rundt intill mottatt ".."
  while (ferdig == 0)
  {
    if (Serial.available() > 0) {
      incomingByte = Serial.read(); // Går inn som ascii fra evt monitor
      if (incomingByte == 46 && incomingByteOld == 46) // ".."
      {
        ferdig = 1;
      }
      incomingByteOld = incomingByte;
    }
  }
  //visStor();

  // antDataWords
  ferdig = 0;
  while (ferdig == 0) {
    if (Serial.available() > 0) {
      incomingByte = Serial.read();
      antDataWords = incomingByte << 8;
      ferdig = 1;
    }
  }
  ferdig = 0;
  while (ferdig == 0) {
    if (Serial.available() > 0) {
      incomingByte = Serial.read();
      antDataWords = antDataWords + incomingByte;
      ferdig = 1;
    }
  }

  // ***************************************

  // see if the card is present and can be initialized:
  if (!SD.begin(chipSelect)) {
    // don't do anything more:
    while (1);
  }

  //if (txtFile)
  //txtFile.close();
  //Serial.println("remove");
  SD.remove("1.txt");

  txtFile = SD.open("1.txt", FILE_WRITE);
  if (!txtFile) {
    Serial.print("error opening ");
    Serial.println("1.txt");
    while (1);
  }
//visStor();
  int dataWordKanal1;
  int dataWordKanal2;
  for (int i = 1 ; i < antDataWords ; i++)
  {
    // ***** Kanal 1
    ferdig = 0;
    while (ferdig == 0)
    {
      if (Serial.available() > 0) {
        incomingByte = Serial.read();
        dataWordKanal1 = incomingByte << 8;
        ferdig = 1;
      }
    }
    ferdig = 0;
    while (ferdig == 0)
    {
      if (Serial.available() > 0) {
        incomingByte = Serial.read();
        dataWordKanal1 = dataWordKanal1  + incomingByte;
        ferdig = 1;
      }
    }
    txtFile.println(dataWordKanal1);
  }
  visStor();
  ferdig = 0;
  txtFile.close();
  
}

// *************************************************************

void visStor(void)
{
  double F = 290;
  double T = 1 / F; // 0.0034 sec
  double d = 1300;
  digitalWrite(3, 1);
  delayMicroseconds(d);
  digitalWrite(3, 0);
  delayMicroseconds(1000000 * T - d);

  delay(1000);

  d = 1700;
  digitalWrite(3, 1);
  delayMicroseconds(d);
  digitalWrite(3, 0);
  delayMicroseconds(1000000 * T - d);

  delay(1000);

  d = 1500;
  digitalWrite(3, 1);
  delayMicroseconds(d);
  digitalWrite(3, 0);
  delayMicroseconds(1000000 * T - d);
}

void visLiten(void)
{
  double F = 290;
  double T = 1 / F; // 0.0034 sec
  double d = 1450;
  digitalWrite(3, 1);
  delayMicroseconds(d);
  digitalWrite(3, 0);
  delayMicroseconds(1000000 * T - d);

  delay(2000);

  d = 1550;
  digitalWrite(3, 1);
  delayMicroseconds(d);
  digitalWrite(3, 0);
  delayMicroseconds(1000000 * T - d);
}
